FLTK 1.4.5: Fl_Tiled_Image Class Reference

FLTK 1.4.5

Loading...
Searching...
No Matches
Fl_Tiled_Image Class Reference

This class supports tiling of images over a specified area. More...

`#include <Fl_Tiled_Image.H>`

Inheritance diagram for Fl_Tiled_Image:

## Public Member Functions
void | color_average (Fl_Color c, float i) FL_OVERRIDE
| The color_average() method averages the colors in the image with the provided FLTK color value.
Fl_Image * | copy () const
Fl_Image * | copy (int W, int H) const FL_OVERRIDE
| Creates a resized copy of the image.
void | desaturate () FL_OVERRIDE
| The desaturate() method converts an image to grayscale.
void | draw (int X, int Y)
void | draw (int X, int Y, int W, int H, int cx=0, int cy=0) FL_OVERRIDE
| Draws a tiled image.
| Fl_Tiled_Image (Fl_Image *i, int W=0, int H=0)
| The constructors create a new tiled image containing the specified image.
Fl_Image * | image ()
| Gets The image that is tiled.
virtual | ~Fl_Tiled_Image ()
| The destructor frees all memory and server resources that are used by the tiled image.
Public Member Functions inherited from Fl_Image
virtual class Fl_Shared_Image * | as_shared_image ()
| Returns whether an image is an Fl_Shared_Image or not.
Fl_Image * | copy () const
| Creates a copy of the image in the same size.
int | count () const
| Returns the number of data values associated with the image.
int | d () const
| Returns the image depth.
const char *const * | data () const
| Returns a pointer to the current image data array.
int | data_h () const
| Returns the height of the image data.
int | data_w () const
| Returns the width of the image data.
void | draw (int X, int Y)
| Draws the image to the current drawing surface.
int | fail () const
| Returns a value that is not 0 if there is currently no image available.
| Fl_Image (int W, int H, int D)
| The constructor creates an empty image with the specified width, height, and depth.
int | h () const
| Returns the current image drawing height in FLTK units.
void | inactive ()
| The inactive() method calls color_average(FL_BACKGROUND_COLOR, 0.33f) to produce an image that appears grayed out.
virtual void | label (Fl_Menu_Item *m)
| This method is an obsolete way to set the image attribute of a menu item.
virtual void | label (Fl_Widget *w)
| This method is an obsolete way to set the image attribute of a widget or menu item.
int | ld () const
| Returns the current line data size in bytes.
virtual void | release ()
| Releases an Fl_Image - the same as '`delete` `this'`.
virtual void | scale (int width, int height, int proportional=1, int can_expand=0)
| Sets the drawing size of the image.
virtual void | uncache ()
| If the image has been cached for display, delete the cache data.
int | w () const
| Returns the current image drawing width in FLTK units.
virtual | ~Fl_Image ()
| The destructor is a virtual method that frees all memory used by the image.

## Protected Attributes
int | alloc_image_
Fl_Image * | image_

## Additional Inherited Members
Static Public Member Functions inherited from Fl_Image
static Fl_Labeltype | define_FL_IMAGE_LABEL ()
static Fl_RGB_Scaling | RGB_scaling ()
| Returns the currently used RGB image scaling method.
static void | RGB_scaling (Fl_RGB_Scaling)
| Sets the RGB image scaling method used for copy(int, int).
static Fl_RGB_Scaling | scaling_algorithm ()
| Gets what algorithm is used when resizing a source image to draw it.
static void | scaling_algorithm (Fl_RGB_Scaling algorithm)
| Sets what algorithm is used when resizing a source image to draw it.
Static Public Attributes inherited from Fl_Image
static const int | ERR_FILE_ACCESS = -2
static const int | ERR_FORMAT = -3
static const int | ERR_MEMORY_ACCESS = -4
static const int | ERR_NO_IMAGE = -1
static bool | register_images_done = false
| True after fl_register_images() was called, false before.
Protected Member Functions inherited from Fl_Image
void | d (int D)
| Sets the current image depth.
void | data (const char *const *p, int c)
| Sets the current data pointer and count of pointers in the array.
void | draw_empty (int X, int Y)
| The protected method draw_empty() draws a box with an X in it.
int | draw_scaled (int X, int Y, int W, int H)
| Draw the image to the current drawing surface rescaled to a given width and height.
void | h (int H)
| Sets the height of the image data.
void | ld (int LD)
| Sets the current line data size in bytes.
void | w (int W)
| Sets the width of the image data.
Static Protected Member Functions inherited from Fl_Image
static void | labeltype (const Fl_Label *lo, int lx, int ly, int lw, int lh, Fl_Align la)
static void | measure (const Fl_Label *lo, int &lw, int &lh)

## Detailed Description

This class supports tiling of images over a specified area.

The source (tile) image is not copied unless you call the color_average(), desaturate(), or inactive() methods.

## Constructor & Destructor Documentation

## ◆ Fl_Tiled_Image()

Fl_Tiled_Image::Fl_Tiled_Image | ( | Fl_Image * | i,
|  | int | W = 0,
|  | int | H = 0 )

The constructors create a new tiled image containing the specified image.

Use a width and height of 0 to tile the whole window/widget.

Note
  Due to implementation constraints in FLTK 1.3.3 and later width and height of 0 may not work as expected when used as background image in widgets other than windows. You may need to center and clip the image (label) and set the label type to FL_NORMAL_LABEL. Doing so will let the tiled image fill the whole widget as its background image. Other combinations of label flags may or may not work.

#include "bg.xpm"
Fl_Pixmap *bg_xpm = new Fl_Pixmap(bg_xpm);
Fl_Tiled_Image *bg_tiled = new Fl_Tiled_Image(bg_xpm,0,0);
Fl_Box *box = new Fl_Box(40,40,300,100,"");
box->box(FL_UP_BOX);
box->labeltype(FL_NORMAL_LABEL);
box->align(FL_ALIGN_INSIDE | FL_ALIGN_CENTER | FL_ALIGN_CLIP);
box->image(bg_tiled);
FL_ALIGN_CENTER
const Fl_Align FL_ALIGN_CENTER
Align the label horizontally in the middle.
Definition Enumerations.H:989
FL_ALIGN_CLIP
const Fl_Align FL_ALIGN_CLIP
All parts of the label that are larger than the widget will not be drawn.
Definition Enumerations.H:1016
FL_NORMAL_LABEL
@ FL_NORMAL_LABEL
draws the text (0)
Definition Enumerations.H:836
FL_ALIGN_INSIDE
const Fl_Align FL_ALIGN_INSIDE
Draw the label inside of the widget.
Definition Enumerations.H:1007
FL_UP_BOX
@ FL_UP_BOX
see figure Standard Box Types
Definition Enumerations.H:648
Fl_Box
This widget simply draws its box, and possibly its label.
Definition Fl_Box.H:34
Fl_Box::Fl_Box
Fl_Box(int X, int Y, int W, int H, const char *L=0)
Creates a new Fl_Box widget with the given coordinates, size, and label.
Definition Fl_Box.cxx:21
Fl_Pixmap
The Fl_Pixmap class supports caching and drawing of colormap (pixmap) images, including transparency.
Definition Fl_Pixmap.H:36
Fl_Pixmap::Fl_Pixmap
Fl_Pixmap(char *const *D)
The constructors create a new pixmap from the specified XPM data.
Definition Fl_Pixmap.H:58
Fl_Tiled_Image::Fl_Tiled_Image
Fl_Tiled_Image(Fl_Image *i, int W=0, int H=0)
The constructors create a new tiled image containing the specified image.
Definition Fl_Tiled_Image.cxx:55
Fl_Widget::align
Fl_Align align() const
Gets the label alignment.
Definition Fl_Widget.H:425
Fl_Widget::box
Fl_Boxtype box() const
Gets the box type of the widget.
Definition Fl_Widget.H:440
Fl_Widget::labeltype
Fl_Labeltype labeltype() const
Gets the label type.
Definition Fl_Widget.H:534
Fl_Widget::image
Fl_Image * image()
Gets the image that is used as part of the widget label when in the active state.
Definition Fl_Widget.H:591

Note
  Setting an image (label) for a window may not work as expected due to implementation constraints in FLTK 1.3.x and maybe later. The reason is the way Fl::scheme() initializes the window's label type and image. A possible workaround is to use another Fl_Group as the only child widget and to set the background image for this group as described above.

Todo
  Fix Fl_Tiled_Image as background image for widgets and windows and fix the implementation of Fl::scheme(const char *).

## Member Function Documentation

## ◆ color_average()

void Fl_Tiled_Image::color_average | ( | Fl_Color | c,
|  | float | i )
| virtual

The color_average() method averages the colors in the image with the provided FLTK color value.

The first argument specifies the FLTK color to be used.

The second argument specifies the amount of the original image to combine with the color, so a value of 1.0 results in no color blend, and a value of 0.0 results in a constant image of the specified color.

An internal copy is made of the original image data before changes are applied, to avoid modifying the original image data in memory.

Reimplemented from Fl_Image.

## ◆ copy()

Fl_Image * Fl_Tiled_Image::copy | ( | int | W,
|  | int | H ) const
| virtual

Creates a resized copy of the image.

It is recommended not to call this member function to reduce the size of an image to the size of the area where this image will be drawn, and to use Fl_Image::scale() instead.

The new image should be released when you are done with it.

Note: since FLTK 1.4.0 you can use Fl_Image::release() for all types of images (i.e. all subclasses of Fl_Image) instead of operator delete for Fl_Image's and Fl_Image::release() for Fl_Shared_Image's.

The new image data will be converted to the requested size. RGB images are resized using the algorithm set by Fl_Image::RGB_scaling().

For the new image the following equations are true:

- w() == data_w() == `W`
- h() == data_h() == `H`

Parameters

  [in] | W,H | Requested width and height of the new image

Note
  The returned image can be safely cast to the same image type as that of the source image provided this type is one of Fl_RGB_Image, Fl_SVG_Image, Fl_Pixmap, Fl_Bitmap, Fl_Tiled_Image, Fl_Anim_GIF_Image and Fl_Shared_Image. Returned objects copied from images of other, derived, image classes belong to the parent class appearing in this list. For example, the copy of an Fl_GIF_Image is an object of class Fl_Pixmap.
  Since FLTK 1.4.0 this method is 'const'. If you derive your own class from Fl_Image or any subclass your overridden methods of 'Fl_Image::copy() const' and 'Fl_Image::copy(int, int) const' must also be 'const' for inheritance to work properly. This is different than in FLTK 1.3.x and earlier where these methods have not been 'const'.

Reimplemented from Fl_Image.

## ◆ desaturate()

void Fl_Tiled_Image::desaturate | ( |  | ) |
| virtual

The desaturate() method converts an image to grayscale.

If the image contains an alpha channel (depth = 4), the alpha channel is preserved.

An internal copy is made of the original image data before changes are applied, to avoid modifying the original image data in memory.

Reimplemented from Fl_Image.

## ◆ draw()

void Fl_Tiled_Image::draw | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | int | cx = 0,
|  | int | cy = 0 )
| virtual

Draws a tiled image.

Tiled images can be used as background images for widgets and windows. However, due to implementation constraints, you must take care when setting label types and alignment flags. Only certain combinations work as expected, others may yield unexpected results and undefined behavior.

This draw method can draw multiple copies of one image in an area given by `X`, `Y`, `W`, `H`.

The optional arguments `cx` and `cy` can be used to crop the image starting at offsets (cx, cy). `cx` and `cy` must be >= 0 (negative values are ignored). If one of the values is greater than the image width or height resp. (`cx` >= image()->w() or `cy` >= image()->h()) nothing is drawn, because the resulting image would be empty.

After calculating the resulting image size the image is drawn as often as necessary to fill the given area, starting at the top left corner.

If both `W` and `H` are 0 the image is repeated as often as necessary to fill the entire window, unless there is a valid clip region. If you want to fill only one particular widget's background, then you should either set a clip region in your draw() method or use the label alignment flags `FL_ALIGN_INSIDE|FL_ALIGN_CLIP` to make sure the image is clipped.

This may be improved in a later version of the library.

Reimplemented from Fl_Image.

The documentation for this class was generated from the following files:

- Fl_Tiled_Image.H
- Fl_Tiled_Image.cxx